//
//  ASHTTPPost.h
//  ASUtilKit
//
//  Created by Jacob Gorban on 03/03/2011.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>

@class ASHTTPPost;

@protocol ASHTTPPostDelegate

- (void)HTTPPost:(ASHTTPPost *)httpPost didFailWithError:(NSError *)error;
- (void)HTTPPostDidFinishLoading:(ASHTTPPost *)httpPost;

@end


@interface ASHTTPPost : NSObject {
	NSURLConnection *mConnection;
	NSMutableURLRequest *mPostRequest;
	NSMutableData *mFormData;
	NSString *agentString;
	NSObject <ASHTTPPostDelegate> *delegate;
	NSHTTPURLResponse *mResponse;
	NSMutableData *mReceivedData;
}

@property (copy, nonatomic) NSString *agentString;
@property (readonly) NSURLConnection *connection;
@property (readonly) NSURLRequest *postRequest;
@property (readonly) NSData *formData;
@property (readonly) NSHTTPURLResponse *response;
@property (readonly) NSData *receivedData;
@property (readonly) NSString *receivedString;
@property (retain, nonatomic) NSObject <ASHTTPPostDelegate> *delegate;

- (void)addNewData:(NSData *)additionalData forFieldName:(NSString *)fieldName;
- (void)addNewString:(NSString *)additionalString forFieldName:(NSString *)fieldName;
- (void)postForm;

@end

